input {
  syslog {
    id => "syslog-eventlog-input"
    port => 514
    tags => [ "eventlog" ]
    codec => plain {
      charset => "ISO-8859-1"
    }
  }

  beats {
    host => "127.0.0.1" 
    port => "5044"
    # ecs_compatibility => "v1"
  }

}

filter {
#
# Pre-parsing filters for snare-style Windows event log forwarding.
# These filters will strip the event headers from the messages and leave the
# "message" field with the remaining event log detail to be parsed by
# downstream filters, as well as tagging the stream with "evt-headers-parsed"
#

  if "eventlog" in [tags] and "evt-headers-parsed" not in [tags] {
    # Copy the logstash event ingestion timestamp
    mutate {
      copy => { "@timestamp" => "logstash-timestamp" }
    }
    # Parse Headers
    grok {
      match => { "message" => 
        "%{DATA:SourceId}(\t+)%{DATA:EventType:int}(\t+)%{DATA:LogName}(\t+)%{NUMBER:RecordNumber:int}(\t+)%{DATA:eventlog_timestamp}(\t+)%{DATA:EventCode:int}(\t+)%{DATA:SourceName}(\t+)(%{DATA:Account}(\t))?(%{DATA:AccountDomain}(\t+))?%{DATA:Keywords}(\t+)%{DATA:ComputerName}(\t+)%{DATA:TaskCategory}(\t+)%{GREEDYDATA:messageEnd}"
      }
      add_tag => "evt-headers-parsed"
      tag_on_failure => [ "_grokparsefailure_headers" ]
    }
    if [messageEnd] {
      mutate {
        replace => { "message" => "%{messageEnd}" }
        remove_field => [ "messageEnd" ]
        rename => [ "SourceId", "[log-headers][SourceId]" ]
        rename => [ "EventType", "[log-headers][EventType]" ]
        rename => [ "LogName", "[log-headers][LogName]" ]
        rename => [ "RecordNumber", "[log-headers][RecordNumber]" ]
        rename => [ "EventCode", "[log-headers][EventCode]" ]
        rename => [ "SourceName", "[log-headers][SourceName]" ]
        rename => [ "Account", "[log-headers][Account]" ]
        rename => [ "AccountDomain", "[log-headers][AccountDomain]" ]
        rename => [ "Keywords", "[log-headers][Keywords]" ]
        rename => [ "ComputerName", "[log-headers][ComputerName]" ]
        rename => [ "TaskCategory", "[log-headers][TaskCategory]" ]
      }
    }
    if [eventlog_timestamp] {
      date {
        match => [ "eventlog_timestamp", "EEE MMM dd HH:mm:ss yyyy" ]
      }
    }
  }
}

filter {
#
# The event log message, data section parsing filters.
# These filters expect that a header-stripping filter was applied earlier in the chain,
# and that successfully header-stripped messages have a "evt-headers-parsed" tag,
# and that the message data has replaced the "message" field in the stream. It is also
# expected that the event's timestamp was parsed and placed in the "eventlog_timestamp"
# field in the stream and that it was converted to a date field. The
# "[log-headers][EventCode]" field must have been parsed from the headers, and must be
# an integer type to match the parsing filter conditionals below.
#

  if "evt-headers-parsed" in [tags] {

    ### Convert all carriage return / line-feeds and tabs to spaces to meet expections of downstream parsers
    mutate {
      gsub => [
        # FIELD, PATTERN, REPLACEMENT
        # replace all carriage returns / linefeeds with a space
        "message", "((\r+)?\n)", " ",
        # replace all tags with a space
        "message", "(\t)", " "
      ]
    }
    
    # account failed to logon
    if [log-headers][EventCode] == 4625 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}(\s{2,}+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s+)%{DATA}:(\s+)%{DATA:logonID}(\s{2,})%{DATA}:(\s{2,})%{DATA:logonType}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:accountSID}(\s{2,})(Account Name):(\s{2,})%{DATA:accountName}(\s{2,})(Account Domain):(\s+)(%{DATA:accountDomain})?(\s+)(Failure Information):(\s{2,})%{DATA}:(\s{2,})%{DATA:failureReason}(\s{2,})%{DATA}:(\s{2,})%{DATA:statusCode}(\s{2,})%{DATA}:(\s{2,})%{DATA:subStatusCode}(\s{2,})%{DATA}:(\s{2,})%{DATA}:(\s+)%{DATA:processID}(\s{2,})%{DATA}:(\s+)%{DATA:processName}(\s{2,})%{DATA}:(\s{2,})%{DATA}:(\s+)%{DATA:workstationName}(\s{2,})%{DATA}:(\s+)%{DATA:sourceAddress}(\s{2,})%{DATA}:(\s+)(%{NUMBER:log.sourcePort:int}|%{DATA})(\s{2,})%{DATA}:(\s{2,})%{DATA}:(\s+)%{DATA:logonProcess}(\s{2,})%{DATA}:(\s+)%{DATA:authenticationPackage}(\s{2,})%{DATA}:(\s+)%{DATA:transitedServices}(\s{2,})%{DATA}:(\s+)%{DATA:packageName}(\s{2,})%{DATA}:(\s+)%{DATA:keyLength}(\s{2,})%{GREEDYDATA:tail}?"
          ]
        }
        add_tag => [ "event-parsed" ]
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          remove_field => [ "message" ]
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSID", "[log][subjectSID]" ]
          rename => [ "subjectName", "[log][subjectName]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "logonID", "[log][logonID]" ]
          rename => [ "logonType", "[log][logonType]" ]
          rename => [ "accountSID", "[log][accountSID]" ]
          rename => [ "accountName", "[log][accountName]" ]
          rename => [ "accountDomain", "[log][accountDomain]" ]
          rename => [ "failureReason", "[log][failureReason]" ]
          rename => [ "statusCode", "[log][statusCode]" ]
          rename => [ "subStatusCode", "[log][subStatusCode]" ]
          rename => [ "processID", "[log][processID]" ]
          rename => [ "processName", "[log][processName]" ]
          rename => [ "workstationName", "[log][workstationName]" ]
          rename => [ "sourceAddress", "[log][sourceAddress]" ]
          rename => [ "log.sourcePort", "[log][sourcePort]" ]
          rename => [ "logonProcess", "[log][logonProcess]" ]
          rename => [ "authenticationPackage", "[log][authenticationPackage]" ]
          rename => [ "transitedServices", "[log][transitedServices]" ]
          rename => [ "packageName", "[log][packageName]" ]
          rename => [ "keyLength", "[log][keyLength]" ]
          rename => [ "tail", "[log][tail]" ]
          strip => [ "[log][title]", "[log][subjectSID]", "[log][subjectName]", "[log][subjectDomain]", "[log][logonID]", "[log][logonType]", "[log][accountSID]", "[log][accountName]", "[log][accountDomain]", "[log][failureReason]", "[log][statusCode]", "[log][subStatusCode]", "[log][processID]", "[log][processName]", "[log][workstationName]", "[log][sourceAddress]", "[log][sourcePort]", "[log][logonProcess]", "[log][authenticationPackage]", "[log][transitedServices]", "[log][packageName]", "[log][keyLength]", "[log][tail]" ]
        }
      }
    }


    # unable to log
    if [log-headers][EventCode] == 521 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}:(\s{2,}+)%{DATA}:(\s+)%{DATA:statusCode}(\s+)%{DATA}: %{DATA:crashOnAuditFail}(\s+)%{DATA}: %{DATA:numberFailedAudits}(\s+)%{GREEDYDATA:tail}?"
          ]
        }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "statusCode", "[log][statusCode]" ]
          rename => [ "crashOnAuditFail", "[log][crashOnAuditFail]" ]
          rename => [ "numberFailedAudits", "[log][numberFailedAudits]" ]
          rename => [ "tail", "[log][tail]" ]
          strip => [ "[log][title]", "[log][statusCode]", "[log][crashOnAuditFail]", "[log][numberFailedAudits]", "[log][tail]" ]
        }
      }
    }
    
     # adfs token validation failure
    if [log-headers][EventCode] == 411 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}(\s{2,}+)%{DATA}(\s+)%{DATA}:(\s+)%{DATA:activityID}(\s+)%{DATA}:(\s+)%{DATA:tokenType}(\s+)%{DATA}:(\s+)(%{IP:externalIP},%{IP:internalIP}|%{IP:internalIP})(\s+)%{DATA}:(\s+)%{DATA:accountName}-%{DATA:errorMessage}(\s{2,})%{DATA}:(\s{2,})%{DATA:exceptionDetails}(\s)%{NUMBER:number:float}%{GREEDYDATA:tail}?"
        ]
        }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "activityID", "[log][activityID]" ]
          rename => [ "tokenType", "[log][tokenType]" ]
          rename => [ "externalIP", "[log][externalIP]" ]
          rename => [ "internalIP", "[log][internalIP]" ]
          rename => [ "accountName", "[log][accountName]" ]
          rename => [ "errorMessage", "[log][errorMessage]" ]
          rename => [ "exceptionDetails", "[log][exceptionDetails]" ]
          strip => [ "[log][title]", "[log][activityID]", "[log][tokenType]", "[log][externalIP]", "[log][internalIP]", "[log][accountName]", "[log][errorMessage]", "[log][exceptionDetails]"
          ]
        }
      }
    }


    # Logon Event
    if [log-headers][EventCode] == 4624 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}(\s{2,})%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s{2,})%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s+)%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)(Logon Information:(\s+))?%{DATA}:(\s+)?%{DATA:logonType}(\s+)(Restricted Admin Mode:(\s+)%{DATA:logonRestrictedAdminMode}(\s+)Virtual Account:(\s+)%{DATA:logonVirtualAccount}(\s+)Elevated Token:(\s+)%{DATA:logonElevatedToken}(\s+))?(Impersonation Level:(\s+)%{DATA:impersonationLevel}(\s+))?(New Logon:(\s+))%{DATA}:(\s+)%{DATA:logonSID}(\s+)(\s+)%{DATA}:(\s+)%{DATA:logonAccount}(\s+)%{DATA}:(\s+)%{DATA:logonDomain}(\s+)%{DATA}:(\s+)%{DATA:logonID}(\s+)((Linked Logon ID:(\s+)%{DATA:linkedLogonId}(\s+))(Network Account Name:(\s+)%{DATA:networkAccount}(\s+))(Network Account Domain:(\s+)%{DATA:networkAccountDomain}(\s+)))?%{DATA}:(\s+)%{DATA:logonGUID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:procID}(\s+)%{DATA}:(\s+)%{DATA:procPath}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:networkWorkstation}(\s+)%{DATA}:(\s+)%{DATA:networkAddress}(\s+)%{DATA}:(\s+)%{DATA:networkPort:int}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:authProcess}(\s+)%{DATA}:(\s+)%{DATA:authPackage}(\s+)%{DATA}:(\s+)%{DATA:authTransitedService}(\s+)%{DATA}:(\s+)%{DATA:authPackageName}(\s+)%{DATA}:(\s+)%{NUMBER:authKeyLength:int}((\s+)%{GREEDYDATA:messageEnd})?"
          ]
        }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          remove_field => [ "messageEnd", "message" ]
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSID]" ]
          rename => [ "subjectName", "[log][subjectAccount]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "logonType", "[log][logonType]" ]
          rename => [ "logonRestrictedAdminMode", "[log][logonRestrictedAdminMode]" ]
          rename => [ "logonVirtualAccount", "[log][logonVirtualAccount]" ]
          rename => [ "logonElevatedToken", "[log][logonElevatedToken]" ]
          rename => [ "impersonationLevel", "[log][impersonationLevel]" ]
          rename => [ "logonSID", "[log][logonSID]" ]
          rename => [ "logonAccount", "[log][logonAccount]" ]
          rename => [ "logonDomain", "[log][logonDomain]" ]
          rename => [ "logonID", "[log][logonID]" ]
          rename => [ "linkedLogonId", "[log][linkedLogonId]" ]
          rename => [ "networkAccount", "[log][networkAccount]" ]
          rename => [ "networkAccountDomain", "[log][networkAccountDomain]" ]
          rename => [ "logonGUID", "[log][logonGUID]" ]
          rename => [ "procID", "[log][processID]" ]
          rename => [ "procPath", "[log][processPath]" ]
          rename => [ "networkWorkstation", "[log][networkWorkstation]" ]
          rename => [ "networkAddress", "[log][networkAddress]" ]
          rename => [ "networkPort", "[log][networkPort]" ]
          rename => [ "authProcess", "[log][authProcess]" ]
          rename => [ "authTransitedService", "[log][authTransitedService]" ]
          rename => [ "authPackage", "[log][authPackage]" ]
          rename => [ "authPackageName", "[log][authPackageName]" ]
          rename => [ "authKeyLength", "[log][authKeyLength]" ]
          strip => [ "[log][title]", "[log][subjectSID]", "[log][subjectAccount]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][logonType]", "[log][impersonationLevel]", "[log][logonSID]", "[log][logonAccount]", "[log][logonDomain]", "[log][logonID]", "[log][logonGUID]", "[log][processID]", "[log][processPath]", "[log][networkWorkstation]", "[log][networkAddress]", "[log][networkPort]" ]
        }
        if [log][networkPort] and [log][networkPort] != "-" {
          mutate {
            convert =>  { "[log][networkPort]" => "integer" }
          }
        }
        if [log][networkPort] and [log][networkPort] == "-" {
          mutate {
            remove_field => [ "[log][networkPort]" ]
          }
        }
      }
    }

    # Kerberos pre-authentication failed message
    if [log-headers][EventCode] == 4771 {
      mutate {
        add_tag => "Kerberos_PreAuth_Failed"
      }
      grok {
        match => { "message" => "%{DATA:log.title}(\s{2,})(%{DATA}:)(\s+)(%{DATA}:)(\s+)%{DATA:log.subjectSID}(\s+)(%{DATA}:(\s+))%{DATA:log.subjectName}(\s{2,})(%{DATA}:(\s+))(%{DATA}:(\s+))%{DATA:log.serviceName}(\s+)(%{DATA}:(\s+))(%{DATA}:(\s+))%{DATA:log.sourceAddress}(\s+)(%{DATA}:(\s+))%{NUMBER:log.sourcePort:int}(\s+)(%{DATA}:(\s+))(%{DATA}:(\s+))%{DATA:log.ticketOptions}(\s+)(%{DATA}:(\s+))%{DATA:log.failureCode}(\s+)(%{DATA}:(\s+))%{DATA:log.ticketPreAuthType:int}(\s+)%{DATA}:(\s+)%{DATA}:%{DATA:log.certIssuer}?(\s+)%{DATA}:%{DATA:log.certSN}?(\s+)%{DATA}:%{DATA:log.certThumb}?(\s+)%{GREEDYDATA:log.additionalInfo}" }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          remove_field => [ "message" ]
          rename => [ "log.title", "[log][title]" ]
          rename => [ "log.subjectSID", "[log][subjectSID]" ]
          rename => [ "log.subjectName", "[log][subjectName]" ]
          rename => [ "log.serviceName", "[log][serviceName]" ]
          rename => [ "log.sourceAddress", "[log][sourceAddress]" ]
          rename => [ "log.sourcePort", "[log][sourcePort]" ]
          rename => [ "log.ticketOptions", "[log][ticketOptions]" ]
          rename => [ "log.failureCode", "[log][failureCode]" ]
          rename => [ "log.ticketPreAuthType", "[log][ticketPreAuthType]" ]
          rename => [ "log.certIssuer", "[log][certIssuer]" ]
          rename => [ "log.certSN", "[log][certSN]" ]
          rename => [ "log.certThumb", "[log][certThumb]" ]
          rename => [ "log.additionalInfo", "[log][additionalInfo]" ]
          strip => [ "[log][title]", "[log][subjectName]", "[log][subjectSID]", "[log][serviceName]", "[log][sourceAddress]", "[log][sourcePort]", "[log][ticketOptions]", "[log][failureCode]", "[log][ticketPreAuthType]", "[log][certIssuer]", "[log][certSN]", "[log][certThumb]" ]
        }
      }
    }
    
        # user object property change
    if [log-headers][EventCode] == 4738 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}(\s{2,}+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s+)%{DATA}:(\s+)%{DATA:logonID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:targetSID}(\s+)%{DATA}:(\s+)%{DATA:targetName}(\s+)%{DATA}:(\s+)%{DATA:targetDomain}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:samName}(\s+)%{DATA}:(\s+)%{DATA:displayName}(\s+)%{DATA}:(\s+)%{DATA:userprincipalName}(\s+)%{DATA}:(\s+)%{DATA:homeDirectory}(\s+)%{DATA}:(\s+)%{DATA:homeDrive}(\s+)%{DATA}:(\s+)%{DATA:scriptPath}(\s+)%{DATA}:(\s+)%{DATA:profilePath}(\s+)%{DATA}:(\s+)%{DATA:userWorkstations}(\s+)%{DATA}:(\s+)%{DATA:passwordLastSet}(\s{2,}+)%{DATA}:(\s+)%{DATA:accountExpires}(\s+)%{DATA}:(\s+)%{DATA:primaryGroupID}(\s+)%{DATA}:(\s+)%{DATA:allowedToDelegateTo}(\s+)%{DATA}:(\s+)%{DATA:oldUACvalue}(\s+)%{DATA}:(\s+)%{DATA:newUACvalue}(\s+)%{DATA}:(\s+)%{DATA:userAccountControl}(\s+){2,}%{DATA}:(\s+)%{DATA:userParameters}(\s+)%{DATA}:(\s+)%{DATA:sidHistory}(\s+)%{DATA}:(\s+)%{DATA:logonHours}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{GREEDYDATA:tail}?"
          ]
        }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSID", "[log][subjectSID]" ]
          rename => [ "subjectName", "[log][subjectName]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "logonID", "[log][logonID]" ]
          rename => [ "targetSID", "[log][targetSID]" ]
          rename => [ "targetName", "[log][targetName]" ]
          rename => [ "targetDomain", "[log][targetDomain]" ]
          rename => [ "samName", "[log][samName]" ]
          rename => [ "displayName", "[log][displayName]" ]
          rename => [ "userprincipalName", "[log][userprincipalName]" ]
          rename => [ "homeDirectory", "[log][homeDirectory]" ]
          rename => [ "homeDrive", "[log][homeDrive]" ]
          rename => [ "scriptPath", "[log][scriptPath]" ]
          rename => [ "profilePath", "[log][profilePath]" ]
          rename => [ "userWorkstations", "[log][userWorkstations]" ]
          rename => [ "passwordLastSet", "[log][passwordLastSet]" ]
          rename => [ "accountExpires", "[log][accountExpires]" ]
          rename => [ "primaryGroupID", "[log][primaryGroupID]" ]
          rename => [ "allowedToDelegateTo", "[log][allowedToDelegateTo]" ]
          rename => [ "oldUACvalue", "[log][oldUACvalue]" ]
          rename => [ "newUACvalue", "[log][newUACvalue]" ]
          rename => [ "userAccountControl", "[log][userAccountControl]" ]
          rename => [ "userParameters", "[log][userParameters]" ]
          rename => [ "sidHistory", "[log][sidHistory]" ]
          rename => [ "logonHours", "[log][logonHours]" ]
          strip => [ "[log][title]", "[log][subjectSID]", "[log][subjectName]", "[log][subjectDomain]", "[log][logonID]", "[log][targetSID]",
            "[log][targetSID]", "[log][targetName]", "[log][targetDomain]",
            "[log][samName]", "[log][displayName]", "[log][userprincipalName]",
            "[log][homeDirectory]", "[log][homeDrive]", "[log][scriptPath]",
            "[log][profilePath]", "[log][userWorkstations]", "[log][passwordLastSet]",
            "[log][accountExpires]", "[log][primaryGroupID]",  
            "[log][allowedToDelegateTo]", "[log][oldUACvalue]", "[log][newUACvalue]",
            "[log][userAccountControl]", "[log][userParameters]", "[log][sidHistory]",
            "[log][logonHours]"
          ]
        }
      }
    }


    # The computer attempted to validate the credentials for an account
    if [log-headers][EventCode] == 4776 {
      grok {
        match => { "message" => "%{DATA:log.title}(\s{2,})(%{DATA}):(\s+)%{DATA:log.authPackage}(\s+)%{DATA}:(\s+)%{DATA:log.logonAccount}(\s+)%{DATA}:(\s+)%{DATA:log.sourceWorkstation}(\s+)%{DATA}:%{SPACE}%{WORD:log.errorCode}((\s+)%{GREEDYDATA:messageEnd})?" }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          remove_field => [ "message" ]
          rename => [ "log.title", "[log][title]" ]
          rename => [ "log.authPackage", "[log][authPackage]" ]
          rename => [ "log.logonAccount", "[log][logonAccount]" ]
          rename => [ "log.sourceWorkstation", "[log][sourceWorkstation]" ]
          rename => [ "log.errorCode", "[log][errorCode]" ]
          strip => [ "[log][title]", "[log][authPackage]", "[log][logonAccount]", "[log][sourceWorkstation]", "[log][errorCode]" ]
        }
      }
    }

    # A Kerberos authentication ticket (TGT) was requested
    if [log-headers][EventCode] == 4768 {
      grok {
        match => { "message" => "%{DATA:messageTitle}(\s{2,})%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s+)%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:serviceName}(\s+)%{DATA}:(\s+)%{DATA:serviceID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:sourceAddress}(\s+)%{DATA}:(\s+)%{NUMBER:sourcePort:int}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:ticketOptions}(\s+)%{DATA}:(\s+)%{DATA:failureCode}(\s+)%{DATA}:(\s+)%{DATA:ticketEnc}(\s+)%{DATA}:(\s+)%{DATA:ticketPreAuthType:int}(\s+)%{DATA}:(\s+)Certificate Issuer Name:((\s+)%{DATA:certIssuer})?(\s+)Certificate Serial Number:((\s+)%{DATA:certSN})?(\s+)Certificate Thumbprint:(\s+)%{DATA:certThumb}?(\s+)(?<additionalInfo>Certificate information%{GREEDYDATA})" }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          remove_field => [ "message" ]
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectName", "[log][subjectName]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "serviceName", "[log][serviceName]" ]
          rename => [ "serviceID", "[log][serviceID]" ]
          rename => [ "sourceAddress", "[log][sourceAddress]" ]
          rename => [ "sourcePort", "[log][sourcePort]" ]
          rename => [ "ticketOptions", "[log][ticketOptions]" ]
          rename => [ "ticketEnc", "[log][ticketEncryption]" ]
          rename => [ "failureCode", "[log][failureCode]" ]
          rename => [ "ticketPreAuthType", "[log][ticketPreAuthType]" ]
          rename => [ "certIssuer", "[log][certIssuer]" ]
          rename => [ "certSN", "[log][certSN]" ]
          rename => [ "certThumb", "[log][certThumb]" ]
          rename => [ "additionalInfo", "[log][additionalInfo]" ]
          strip => [ "[log][title]", "[log][subjectName]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][serviceName]", "[log][serviceID]", "[log][sourceAddress]", "[log][sourcePort]", "[log][ticketOptions]", "[log][ticketEncryption]", "[log][failureCode]", "[log][ticketPreAuthType]", "[log][certIssuer]", "[log][certSN]", "[log][certThumb]" ]
        }
      }
    }

    # Kerberos Service Ticket Operations
    if [log-headers][EventCode] == 4769 {
      grok {
        match => { "message" => "%{DATA:log.title}(\s{2,})%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:log.subjectName}(\s+)%{DATA}:(\s+)%{DATA:log.subjectDomain}(\s+)%{DATA}:(\s+)%{DATA:log.subjectLogonGUID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:log.serviceName}(\s+)%{DATA}:(\s+)%{DATA:log.serviceID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:log.sourceAddr}(\s+)%{DATA}:(\s+)%{NUMBER:log.sourcePort:int}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:log.ticketOptions}(\s+)%{DATA}:(\s+)%{DATA:log.ticketEnc}(\s+)%{DATA}:(\s+)%{DATA:log.failureCode}(\s+)%{DATA}:(\s+)%{DATA:log.transitedServices}(\s+)%{GREEDYDATA:log.additionalInfo}" }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          remove_field => [ "message" ]
          rename => [ "log.title", "[log][title]" ]
          rename => [ "log.subjectName", "[log][subjectName]" ]
          rename => [ "log.subjectDomain", "[log][subjectDomain]" ]
          rename => [ "log.subjectLogonGUID", "[log][subjectLogonGUID]" ]
          rename => [ "log.serviceName", "[log][serviceName]" ]
          rename => [ "log.serviceID", "[log][serviceID]" ]
          rename => [ "log.sourceAddr", "[log][sourceAddress]" ]
          rename => [ "log.sourcePort", "[log][sourcePort]" ]
          rename => [ "log.ticketOptions", "[log][ticketOptions]" ]
          rename => [ "log.ticketEnc", "[log][ticketEncryption]" ]
          rename => [ "log.failureCode", "[log][failureCode]" ]
          rename => [ "log.transitedServices", "[log][transitedServices]" ]
          rename => [ "log.additionalInfo", "[log][additionalInfo]" ]
          strip => [ "[log][title]", "[log][subjectName]", "[log][subjectDomain]", "[log][subjectLogonGUID]", "[log][serviceName]", "[log][serviceID]", "[log][sourceAddress]", "[log][sourcePort]", "[log][ticketOptions]", "[log][ticketEncryption]", "[log][failureCode]", "[log][transitedServices]", "[log][additionalInfo]" ]
        }
      }
    }

    # Handle To An Object Requested
    if [log-headers][EventCode] == 4661 {
      grok {
        match => { "message" => "(?m)%{DATA:messageTitle}(\s{2,}+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s+)%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:objectServer}(\s+)%{DATA}:(\s+)%{DATA:objectType}(\s+)%{DATA}:(\s+)%{DATA:objectName}(\s+)%{DATA}:(\s+)%{DATA:handleId}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:processID}(\s+)%{DATA}:(\s+)%{DATA:processPath}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:transactionId}(\s+)%{DATA}:(\s+)%{DATA:accesses}(\s+)Access Reasons:(\s+)%{DATA:accessReasons}(\s+)%{DATA}:(\s+)%{DATA:accessMask}(\s+)%{DATA}:(\s+)%{DATA:accessCheckPrivileges}(\s+)%{DATA}(\s+)%{DATA:properties}(\s+)Restricted SID Count:(\s+)%{NUMBER:restrictedSIDCount}%{GREEDYDATA:messageEnd}*" }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          copy => { "properties" => "propertiesWildcard" }
        }
        mutate {
          remove_field => [ "messageEnd", "message" ]
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSID]" ]
          rename => [ "subjectName", "[log][subjectAccount]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "accessMask", "[log][accessMask]" ]
          rename => [ "accessReasons", "[log][accessReasons]" ]
          rename => [ "accessCheckPrivileges", "[log][accessCheckPrivileges]" ]
          rename => [ "accesses", "[log][accesses]" ]
          rename => [ "objectServer", "[log][objectServer]" ]
          rename => [ "objectType", "[log][objectType]" ]
          rename => [ "objectName", "[log][objectName]" ]
          rename => [ "transactionId", "[log][transactionId]" ]
          rename => [ "handleId", "[log][handleId]" ]
          rename => [ "processID", "[log][processID]" ]
          rename => [ "properties", "[log][properties]" ]
          rename => [ "propertiesWildcard", "[log][properties_wildcard]" ]
          rename => [ "restrictedSIDCount", "[log][restrictedSIDCount]" ]
          strip => [ "[log][title]", "[log][subjectSID]", "[log][subjectAccount]", "[log][subjectDomain]", "[log][subjectLogonID]" , "[log][accessMask]", "[log][accessReasons]", "[log][accessCheckPrivileges]", "[log][accesses]", "[log][objectServer]", "[log][objectType]" , "[log][objectName]", "[log][transactionId]", "[log][processID]", "[log][properties]", "[log][properties_wildcard]", "[log][restrictedSIDCount]" ]
        }
      }
    }

    # Operation performed on an object
    if [log-headers][EventCode] == 4662 {
      grok {
        match => { "message" =>  "%{DATA:messageTitle}(\s{2,}+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s+)%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:objectServer}(\s+)%{DATA}:(\s+)%{DATA:objectType}(\s+)%{DATA}:(\s+)%{DATA:objectName}(\s+)%{DATA}:(\s+)%{DATA:objectHandleID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:operationType}(\s{2,}+)%{DATA}:(\s+)%{DATA:operationAccesses}(\s{2,}+)%{DATA}:(\s+)%{DATA:operationAccessMask}(\s+)%{DATA}:(\s+)%{DATA:operationProperties}(\s{2,}+)Additional Information:(\s+)%{DATA}:(\s+)%{DATA:addtionalInfoParam1}(\s+)%{DATA}:((\s+)%{GREEDYDATA:addtionalInfoParam2})?"}
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          copy => { "operationProperties" => "operationPropertiesWildcard" }
        }
        mutate {
          remove_field => [ "messageEnd", "message" ]
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSID]" ]
          rename => [ "subjectName", "[log][subjectAccount]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "objectServer", "[log][objectServer]" ]
          rename => [ "objectType", "[log][objectType]" ]
          rename => [ "objectName", "[log][objectName]" ]
          rename => [ "objectHandleID", "[log][objectHandleID]" ]
          rename => [ "operationType", "[log][operationType]" ]
          rename => [ "operationAccesses", "[log][operationAccesses]" ]
          rename => [ "operationAccessMask", "[log][operationAccessMask]" ]
          rename => [ "operationProperties", "[log][properties]" ]
          rename => [ "operationPropertiesWildcard", "[log][properties_wildcard]" ]
          rename => [ "addtionalInfoParam1", "[log][addtionalInfoParam1]" ]
          rename => [ "addtionalInfoParam2", "[log][addtionalInfoParam2]" ]
          strip => [ "[log][title]", "[log][subjectSID]" , "[log][subjectSID]" , "[log][subjectAccount]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][objectServer]", "[log][objectType]", "[log][objectName]", "[log][objectHandleID]" , "[log][operationType]", "[log][operationAccesses]", "[log][operationAccessMask]", "[log][properties]", "[log][properties_wildcard]", "[log][addtionalInfoParam1]", "[log][addtionalInfoParam2]" ]
        }
      }
    }

    # Attempt made to access an object
    if [log-headers][EventCode] == 4663 {
      grok {
        match => { "message" =>  "%{DATA:messageTitle}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s+)%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:objectServer}(\s+)%{DATA}:(\s+)%{DATA:objectType}(\s+)%{DATA}:(\s+)%{DATA:objectName}(\s+)%{DATA}:(\s+)%{DATA:objectHandleID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:processID}(\s+)%{DATA}:(\s+)%{DATA:processPath}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:accessRequestInfoAccess}(\s+)%{DATA}:(\s+)%{DATA:accessRequestInfoAccessMask}(\s+)%{DATA}((\s+)%{GREEDYDATA:messageEnd})?" }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          remove_field => [ "messageEnd", "message" ]
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSID]" ]
          rename => [ "subjectName", "[log][subjectAccount]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "objectServer", "[log][objectServer]" ]
          rename => [ "objectType", "[log][objectType]" ]
          rename => [ "objectName", "[log][objectName]" ]
          rename => [ "objectHandleID", "[log][objectHandleID]" ]
          rename => [ "processID", "[log][processID]" ]
          rename => [ "processPath", "[log][processPath]" ]
          rename => [ "accessRequestInfoAccess", "[log][accessRequestInfoAccess]" ]
          rename => [ "accessRequestInfoAccessMask", "[log][accessRequestInfoAccessMask]"]
          strip => [ "[log][title]", "[log][subjectSID]", "[log][subjectAccount]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][objectServer]", "[log][objectType]", "[log][objectName]", "[log][objectHandleID]", "[log][processID]", "[log][processPath]", "[log][accessRequestInfoAccess]", "[log][accessRequestInfoAccessMask]" ]
        }
      }
    }

    # Logoff
    if [log-headers][EventCode] == 4634 {
      grok {
        match => { "message" => "%{DATA:messageTitle}(\s{2,}+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s+)%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:(\s+)%{DATA:logonType}(\s+)(%{GREEDYDATA:messageEnd})?" }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          remove_field => [ "subjectHeader", "subjectSecurityIDTitle", "subjectNameTitle", "subjectDomainTitle", "subjectLogonIDTitle", "logonTypeTitle", "messageEnd", "message" ]
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSID]" ]
          rename => [ "subjectName", "[log][subjectAccount]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "logonType", "[log][subjectLogonType]" ]
          strip => [ "[log][title]", "[log][subjectSID]", "[log][subjectAccount]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][privilegesType]" ]
        }
      }
    }

    # Process Creation
    if [log-headers][EventCode] == 4688 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}(\s{2,})%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s+)%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:targetSubjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:targetSubjectName}(\s+)%{DATA}:(\s+)%{DATA:targetSubjectDomain}(\s+)%{DATA}:(\s+)%{DATA:targetSubjectLogonID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:procID}(\s+)%{DATA}:(\s+)%{DATA:procPath}(\s{2,})%{DATA}:(\s+)%{DATA:tokenType}(\s+)%{DATA}:(\s+)%{DATA:procLabel}(\s+)%{DATA}:(\s+)%{DATA:creatorProcID}(\s+)%{DATA}:(\s+)%{DATA:creatorName}(\s{2,})%{DATA}:(\s+)%{DATA:procCmdline}?(\s+)(?<messageEnd>Token Elevation%{GREEDYDATA})",
          "%{DATA:messageTitle}(\s{2,})%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s+)%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:procID}(\s+)%{DATA}:(\s+)%{DATA:newProcPath}(\s{2,})%{DATA}:(\s+)%{DATA:tokenType}(\s{2,})%{DATA}:(\s+)%{DATA:procLabel}(\s{2,})%{DATA}:%{DATA:creatorProcID}(\s{2,})%{DATA}:(\s+)%{DATA:creatorName}(\s{2,})%{DATA}:(\s+)%{DATA:procCmdline}?(\s+)(?<messageEnd>Token Elevation%{GREEDYDATA})"
        ]}
        break_on_match => "true"
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          remove_field => [ "message", "messageEnd" ]
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSID]" ]
          rename => [ "subjectName", "[log][subjectAccount]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "targetSubjectSecurityID", "[log][targetSubjectSecurityID]" ]
          rename => [ "targetSubjectName", "[log][targetSubjectName]" ]
          rename => [ "targetSubjectDomain", "[log][targetSubjectDomain]" ]
          rename => [ "targetSubjectLogonID", "[log][targetSubjectLogonID]" ]
          rename => [ "procID", "[log][processID]" ]
          rename => [ "procPath", "[log][processPath]" ]
          rename => [ "procLabel", "[log][processLabel]" ]
          rename => [ "tokenType", "[log][tokenType]" ]
          rename => [ "creatorName", "[log][processParent]" ]
          rename => [ "procCmdline", "[log][procCmdline]" ]
          strip => [ "[log][title]", "[log][subjectSID]", "[log][subjectAccount]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][targetSubjectSecurityID]", "[log][targetSubjectName]", "[log][targetSubjectDomain]", "[log][targetSubjectLogonID]", "[log][processID]", "[log][processPath]", "[log][processLabel]", "[log][tokenType]", "[log][processParent]", "[log][procCmdline]" ]
        }
      }
    }

    # AD Modify Object
    if [log-headers][EventCode] == 5136 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}(\s{2,}+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s{2,})%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:%{DATA}: %{DATA:directoryServiceName}(\s+)%{DATA}: %{DATA:directoryServiceType}(\s{2,})%{DATA}:(\s+)%{DATA}: %{DATA:objectDN}(\s{2,})%{DATA}: %{DATA:objectName}(\s+)%{DATA}: %{DATA:objectType}(\s+)%{DATA}:(\s+)%{DATA}: %{DATA:objectAttribute}(\s+)%{DATA}: %{DATA:objectOID}(\s+)%{DATA}: %{DATA:attributeValue}(\s{2,})%{DATA}:(\s+)%{DATA}: %{DATA:operationType}(\s{2,})%{DATA}: %{DATA:correlationGUID}(\s+)%{DATA}: %{GREEDYDATA:applicationID}?"
          ]
        }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          copy => { "attributeValue" => "attributeValueWildcard" }
        }
        mutate {
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSID]" ]
          rename => [ "subjectName", "[log][subjectAccount]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "directoryServiceName", "[log][directoryServiceName]" ]
          rename => [ "directoryServiceType", "[log][directoryServiceType]" ]
          rename => [ "objectDN", "[log][objectDN]" ]
          rename => [ "objectName", "[log][objectName]" ]
          rename => [ "objectType", "[log][objectType]" ]
          rename => [ "objectAttribute", "[log][objectAttribute]" ]
          rename => [ "objectOID", "[log][objectOID]" ]
          rename => [ "attributeValue", "[log][attributeValue]" ]
          rename => [ "attributeValueWildcard", "[log][attributeValue_wildcard]" ]
          rename => [ "operationType", "[log][operationType]" ]
          rename => [ "correlationGUID", "[log][correlationGUID]" ]
          rename => [ "applicationID", "[log][applicationID]" ]
          strip => [ "[log][title]", "[log][subjectSID]", "[log][subjectAccount]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][directoryServiceName]", "[log][directoryServiceType]", "[log][objectDN]", "[log][objectName]", "[log][objectType]", "[log][objectAttribute]", "[log][objectOID]", "[log][attributeValue]", "[log][attributeValue_wildcard]", "[log][operationType]", "[log][correlationGUID]", "[log][applicationID]" ]
        }
      }
    }

    # AD Create Object
    if [log-headers][EventCode] == 5137 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}(\s{2,}+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s{2,})%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:%{DATA}: %{DATA:directoryServiceName}(\s+)%{DATA}: %{DATA:directoryServiceType}(\s{2,})%{DATA}:(\s+)%{DATA}: %{DATA:objectDN}(\s{2,})%{DATA}: %{DATA:objectName}(\s+)%{DATA}: %{DATA:objectType}(\s{2,})%{DATA}:(\s+)%{DATA}: %{DATA:correlationGUID}(\s+)%{DATA}: %{GREEDYDATA:applicationID}?"
          ]
        }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSID]" ]
          rename => [ "subjectName", "[log][subjectAccount]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "directoryServiceName", "[log][directoryServiceName]" ]
          rename => [ "directoryServiceType", "[log][directoryServiceType]" ]
          rename => [ "objectDN", "[log][objectDN]" ]
          rename => [ "objectName", "[log][objectName]" ]
          rename => [ "objectType", "[log][objectType]" ]
          rename => [ "correlationGUID", "[log][correlationGUID]" ]
          rename => [ "applicationID", "[log][applicationID]" ]
          strip => [ "[log][title]", "[log][subjectSID]", "[log][subjectAccount]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][directoryServiceName]", "[log][directoryServiceType]", "[log][objectDN]", "[log][objectName]", "[log][objectType]",  "[log][correlationGUID]", "[log][applicationID]" ]
        }
      }
    }

    # AD Delete Object
    if [log-headers][EventCode] == 5141 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}(\s{2,}+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s{2,})%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:%{DATA}: %{DATA:directoryServiceName}(\s+)%{DATA}: %{DATA:directoryServiceType}(\s{2,})%{DATA}:(\s+)%{DATA}: %{DATA:objectDN}(\s{2,})%{DATA}: %{DATA:objectName}(\s+)%{DATA}: %{DATA:objectType}(\s{2,})%{DATA}:(\s+)%{DATA}: %{DATA:treeDelete}(\s+)%{DATA}: %{DATA:correlationGUID}(\s+)%{DATA}: %{GREEDYDATA:applicationID}?"
          ]
        }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSID]" ]
          rename => [ "subjectName", "[log][subjectAccount]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "directoryServiceName", "[log][directoryServiceName]" ]
          rename => [ "directoryServiceType", "[log][directoryServiceType]" ]
          rename => [ "objectDN", "[log][objectDN]" ]
          rename => [ "objectName", "[log][objectName]" ]
          rename => [ "objectType", "[log][objectType]" ]
          rename => [ "treeDelete", "[log][treeDelete]" ]
          rename => [ "correlationGUID", "[log][correlationGUID]" ]
          rename => [ "applicationID", "[log][applicationID]" ]
          strip => [ "[log][title]", "[log][subjectSID]", "[log][subjectAccount]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][directoryServiceName]", "[log][directoryServiceType]", "[log][objectDN]", "[log][objectName]", "[log][objectType]",  "[log][treeDelete]", "[log][correlationGUID]", "[log][applicationID]" ]
        }
      }
    }

    # add member to global group
    if [log-headers][EventCode] == 4728 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}(\s{2,}+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s{2,})%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:memberSID}(\s+)%{DATA}:(\s+)%{DATA:accountName}(\s{2,})%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:groupSID}(\s{2,})%{DATA}:(\s{2,})%{DATA:groupName}(\s{2,})%{DATA}:(\s+)%{DATA:groupDomain}(\s+)%{DATA}:(\s+)%{DATA}:%{GREEDYDATA:privileges}?"
          ]
        }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSecurityID]" ]
          rename => [ "subjectName", "[log][subjectName]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "memberSID", "[log][memberSID]" ]
          rename => [ "accountName", "[log][accountName]" ]
          rename => [ "groupSID", "[log][groupSID]" ]
          rename => [ "groupName", "[log][groupName]" ]
          rename => [ "groupDomain", "[log][groupDomain]" ]
          rename => [ "privileges", "[log][privileges]" ]
          strip => [ "[log][title]", "[log][subjectSecurityID]", "[log][subjectName]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][memberSID]", "[log][accountName]", "[log][groupSID]", "[log][groupName]", "[log][groupDomain]", "[log][privileges]" ]
        }
      }
    }

    # remove member to global group
    if [log-headers][EventCode] == 4729 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}(\s{2,}+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s{2,})%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:memberSID}(\s+)%{DATA}:(\s+)%{DATA:accountName}(\s{2,})%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:groupSID}(\s{2,})%{DATA}:(\s{2,})%{DATA:groupName}(\s{2,})%{DATA}:(\s+)%{DATA:groupDomain}(\s+)%{DATA}:(\s+)%{DATA}:%{GREEDYDATA:privileges}?"
          ]
        }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSecurityID]" ]
          rename => [ "subjectName", "[log][subjectName]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "memberSID", "[log][memberSID]" ]
          rename => [ "accountName", "[log][accountName]" ]
          rename => [ "groupSID", "[log][groupSID]" ]
          rename => [ "groupName", "[log][groupName]" ]
          rename => [ "groupDomain", "[log][groupDomain]" ]
          rename => [ "privileges", "[log][privileges]" ]
          strip => [ "[log][title]", "[log][subjectSecurityID]", "[log][subjectName]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][memberSID]", "[log][accountName]", "[log][groupSID]", "[log][groupName]", "[log][groupDomain]", "[log][privileges]"
          ]
        }
      }
    }

    # add member to local group
    if [log-headers][EventCode] == 4732 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}(\s{2,}+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s{2,})%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:memberSID}(\s+)%{DATA}:(\s+)%{DATA:accountName}(\s{2,})%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:groupSID}(\s{2,})%{DATA}:(\s{2,})%{DATA:groupName}(\s{2,})%{DATA}:(\s+)%{DATA:groupDomain}(\s+)%{DATA}:(\s+)%{DATA}:%{GREEDYDATA:privileges}?"
          ]
        }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSecurityID]" ]
          rename => [ "subjectName", "[log][subjectName]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "memberSID", "[log][memberSID]" ]
          rename => [ "accountName", "[log][accountName]" ]
          rename => [ "groupSID", "[log][groupSID]" ]
          rename => [ "groupName", "[log][groupName]" ]
          rename => [ "groupDomain", "[log][groupDomain]" ]
          rename => [ "privileges", "[log][privileges]" ]
          strip => [ "[log][title]", "[log][subjectSecurityID]", "[log][subjectName]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][memberSID]", "[log][accountName]", "[log][groupSID]", "[log][groupName]", "[log][groupDomain]", "[log][privileges]"
          ]
        }
      }
    }

    # remove member to local group
    if [log-headers][EventCode] == 4733 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}(\s{2,}+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s{2,})%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:memberSID}(\s+)%{DATA}:(\s+)%{DATA:accountName}(\s{2,})%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:groupSID}(\s{2,})%{DATA}:(\s{2,})%{DATA:groupName}(\s{2,})%{DATA}:(\s+)%{DATA:groupDomain}(\s+)%{DATA}:(\s+)%{DATA}:%{GREEDYDATA:privileges}?"
          ]
        }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSecurityID]" ]
          rename => [ "subjectName", "[log][subjectName]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "memberSID", "[log][memberSID]" ]
          rename => [ "accountName", "[log][accountName]" ]
          rename => [ "groupSID", "[log][groupSID]" ]
          rename => [ "groupName", "[log][groupName]" ]
          rename => [ "groupDomain", "[log][groupDomain]" ]
          rename => [ "privileges", "[log][privileges]" ]
          strip => [ "[log][title]", "[log][subjectSecurityID]", "[log][subjectName]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][memberSID]", "[log][accountName]", "[log][groupSID]", "[log][groupName]", "[log][groupDomain]", "[log][privileges]"
          ]
        }
      }
    }

    # add member to universal group
    if [log-headers][EventCode] == 4756 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}(\s{2,}+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s{2,})%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:memberSID}(\s+)%{DATA}:(\s+)%{DATA:accountName}(\s{2,})%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:groupSID}(\s{2,})%{DATA}:(\s{2,})%{DATA:groupName}(\s{2,})%{DATA}:(\s+)%{DATA:groupDomain}(\s+)%{DATA}:(\s+)%{DATA}:%{GREEDYDATA:privileges}?"
          ]
        }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSecurityID]" ]
          rename => [ "subjectName", "[log][subjectName]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "memberSID", "[log][memberSID]" ]
          rename => [ "accountName", "[log][accountName]" ]
          rename => [ "groupSID", "[log][groupSID]" ]
          rename => [ "groupName", "[log][groupName]" ]
          rename => [ "groupDomain", "[log][groupDomain]" ]
          rename => [ "privileges", "[log][privileges]" ]
          strip => [ "[log][title]", "[log][subjectSecurityID]", "[log][subjectName]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][memberSID]", "[log][accountName]", "[log][groupSID]", "[log][groupName]", "[log][groupDomain]", "[log][privileges]"
          ]
        }
      }
    }

    # remove member to universal group
    if [log-headers][EventCode] == 4757 {
      grok {
        match => { "message" => [
          "%{DATA:messageTitle}(\s{2,}+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:subjectSecurityID}(\s+)%{DATA}:(\s+)%{DATA:subjectName}(\s+)%{DATA}:(\s+)%{DATA:subjectDomain}(\s{2,})%{DATA}:(\s+)%{DATA:subjectLogonID}(\s+)%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:memberSID}(\s+)%{DATA}:(\s+)%{DATA:accountName}(\s{2,})%{DATA}:(\s+)%{DATA}:(\s+)%{DATA:groupSID}(\s{2,})%{DATA}:(\s{2,})%{DATA:groupName}(\s{2,})%{DATA}:(\s+)%{DATA:groupDomain}(\s+)%{DATA}:(\s+)%{DATA}:%{GREEDYDATA:privileges}?"
          ]
        }
        add_tag => "event-parsed"
      }
      if "_grokparsefailure" not in [tags] {
        mutate {
          rename => [ "messageTitle", "[log][title]" ]
          rename => [ "subjectSecurityID", "[log][subjectSecurityID]" ]
          rename => [ "subjectName", "[log][subjectName]" ]
          rename => [ "subjectDomain", "[log][subjectDomain]" ]
          rename => [ "subjectLogonID", "[log][subjectLogonID]" ]
          rename => [ "memberSID", "[log][memberSID]" ]
          rename => [ "accountName", "[log][accountName]" ]
          rename => [ "groupSID", "[log][groupSID]" ]
          rename => [ "groupName", "[log][groupName]" ]
          rename => [ "groupDomain", "[log][groupDomain]" ]
          rename => [ "privileges", "[log][privileges]" ]
          strip => [ "[log][title]", "[log][subjectSecurityID]", "[log][subjectName]", "[log][subjectDomain]", "[log][subjectLogonID]", "[log][memberSID]", "[log][accountName]", "[log][groupSID]", "[log][groupName]", "[log][groupDomain]", "[log][privileges]"
          ]
        }
      }
    }

    # Add negative "testRecord" header field if we have a successfully parsed message
    if "event-parsed" in [tags] {
      mutate {
        add_field => { "[log-headers][testRecord]" => false }
        add_tag => [ "win-wec-events" ]
      }
    }

  }
}
